
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Organization_membershipsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const organization_memberships = await db.organization_memberships.create(
            {
                id: data.id || undefined,
        
        member_role: data.member_role
        ||
        null
            ,
            
        is_primary: data.is_primary
        ||
        false
        
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        job_title: data.job_title
        ||
        null
            ,
            
        phone: data.phone
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await organization_memberships.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await organization_memberships.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return organization_memberships;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const organization_membershipsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                member_role: item.member_role
            ||
            null
            ,
            
                is_primary: item.is_primary
            ||
            false
        
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                job_title: item.job_title
            ||
            null
            ,
            
                phone: item.phone
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const organization_memberships = await db.organization_memberships.bulkCreate(organization_membershipsData, { transaction });

        // For each item created, replace relation files
        

        return organization_memberships;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const organization_memberships = await db.organization_memberships.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.member_role !== undefined) updatePayload.member_role = data.member_role;
        
        
        if (data.is_primary !== undefined) updatePayload.is_primary = data.is_primary;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.job_title !== undefined) updatePayload.job_title = data.job_title;
        
        
        if (data.phone !== undefined) updatePayload.phone = data.phone;
        
        
        updatePayload.updatedById = currentUser.id;

        await organization_memberships.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await organization_memberships.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await organization_memberships.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return organization_memberships;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const organization_memberships = await db.organization_memberships.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of organization_memberships) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of organization_memberships) {
                await record.destroy({transaction});
            }
        });


        return organization_memberships;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const organization_memberships = await db.organization_memberships.findByPk(id, options);

        await organization_memberships.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await organization_memberships.destroy({
            transaction
        });

        return organization_memberships;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const organization_memberships = await db.organization_memberships.findOne(
            { where },
            { transaction },
        );

        if (!organization_memberships) {
            return organization_memberships;
        }

        const output = organization_memberships.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await organization_memberships.getOrganization({
            transaction
        });
        
        
        output.user = await organization_memberships.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.job_title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'organization_memberships',
                        'job_title',
                        filter.job_title,
                    ),
                };
            }
            
            if (filter.phone) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'organization_memberships',
                        'phone',
                        filter.phone,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.member_role) {
                where = {
                    ...where,
                member_role: filter.member_role,
            };
            }
            
            if (filter.is_primary) {
                where = {
                    ...where,
                is_primary: filter.is_primary,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.organization_memberships.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'organization_memberships',
                        'job_title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.organization_memberships.findAll({
            attributes: [ 'id', 'job_title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['job_title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.job_title,
        }));
    }

    
};

